# std::thread::hardware_concurrency

From cppreference.com
< cpp‎ | thread‎ | thread

static unsigned hardware_concurrency(); |  | (since C++11)

Returns the number of concurrent threads supported by the implementation. The value should be considered only a hint.

### Parameters

(none)

### Return value

number of concurrent threads supported. If the value is not well defined or not computable, returns ​0​.

### Exceptions

`noexcept` specification:
noexcept

### Example

Run this code

    #include <iostream>
    #include <thread>

    int main() {
        unsigned int n = std::thread::hardware_concurrency();
        std::cout << n << " concurrent threads are supported.\n";
    }

Possible output:

    4 concurrent threads are supported.

### See also

hardware_destructive_interference_size hardware_constructive_interference_size (C++17) | min offset to avoid false sharing max offset to promote true sharing (constant)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/thread/thread/hardware_concurrency&oldid=91735"
Category:

- unconditionally noexcept

Hidden categories:

- Pages with unreviewed unconditional noexcept template
- Pages with unreviewed noexcept template